diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-ru.h ns-3.43/src/wifi/model/he/he-ru.h
--- ns-3.42/src/wifi/model/he/he-ru.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-ru.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -20,6 +9,8 @@
 #ifndef HE_RU_H
 #define HE_RU_H
 
+#include "ns3/wifi-phy-common.h"
+
 #include <cstdint>
 #include <map>
 #include <ostream>
@@ -99,11 +90,11 @@
         /**
          * Get the RU PHY index
          *
-         * \param bw the width of the channel of which the RU is part (in MHz)
+         * \param bw the width of the channel of which the RU is part
          * \param p20Index the index of the primary20 channel
          * \return the RU PHY index
          */
-        std::size_t GetPhyIndex(uint16_t bw, uint8_t p20Index) const;
+        std::size_t GetPhyIndex(MHz_u bw, uint8_t p20Index) const;
 
         /**
          * Compare this RU to the given RU.
@@ -142,10 +133,10 @@
         /**
          * Constructor.
          *
-         * \param channelWidth the channel width in MHz
+         * \param channelWidth the channel width
          * \param p20Index the index of the primary20 channel
          */
-        RuSpecCompare(uint16_t channelWidth, uint8_t p20Index);
+        RuSpecCompare(MHz_u channelWidth, uint8_t p20Index);
         /**
          * Function call operator.
          *
@@ -158,39 +149,39 @@
         bool operator()(const RuSpec& lhs, const RuSpec& rhs) const;
 
       private:
-        uint16_t m_channelWidth; ///< The channel width in MHz
-        uint8_t m_p20Index;      ///< Primary20 channel index
+        MHz_u m_channelWidth; ///< The channel width
+        uint8_t m_p20Index;   ///< Primary20 channel index
     };
 
     /**
      * Get the number of distinct RUs of the given type (number of tones)
      * available in a HE PPDU of the given bandwidth.
      *
-     * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+     * \param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
      * \param ruType the RU type (number of tones)
      * \return the number of distinct RUs available
      */
-    static std::size_t GetNRus(uint16_t bw, RuType ruType);
+    static std::size_t GetNRus(MHz_u bw, RuType ruType);
 
     /**
      * Get the set of distinct RUs of the given type (number of tones)
      * available in a HE PPDU of the given bandwidth.
      *
-     * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+     * \param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
      * \param ruType the RU type (number of tones)
      * \return the set of distinct RUs available
      */
-    static std::vector<HeRu::RuSpec> GetRusOfType(uint16_t bw, HeRu::RuType ruType);
+    static std::vector<HeRu::RuSpec> GetRusOfType(MHz_u bw, HeRu::RuType ruType);
 
     /**
      * Get the set of 26-tone RUs that can be additionally allocated if the given
      * bandwidth is split in RUs of the given type.
      *
-     * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+     * \param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
      * \param ruType the RU type (number of tones)
      * \return the set of 26-tone RUs that can be additionally allocated
      */
-    static std::vector<HeRu::RuSpec> GetCentral26TonesRus(uint16_t bw, HeRu::RuType ruType);
+    static std::vector<HeRu::RuSpec> GetCentral26TonesRus(MHz_u bw, HeRu::RuType ruType);
 
     /**
      * Get the subcarrier group of the RU having the given PHY index among all the
@@ -201,37 +192,37 @@
      * the 160 MHz channel (i.e. -1012 to 1012). The PHY index parameter is used to
      * distinguish between lower and higher 80 MHz subchannels.
      *
-     * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+     * \param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
      * \param ruType the RU type (number of tones)
      * \param phyIndex the PHY index (starting at 1) of the RU
      * \return the subcarrier range of the specified RU
      */
-    static SubcarrierGroup GetSubcarrierGroup(uint16_t bw, RuType ruType, std::size_t phyIndex);
+    static SubcarrierGroup GetSubcarrierGroup(MHz_u bw, RuType ruType, std::size_t phyIndex);
 
     /**
      * Check whether the given RU overlaps with the given set of RUs.
      * Note that for channel width of 160 MHz the returned range is relative to
      * the 160 MHz channel (i.e. -1012 to 1012).
      *
-     * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+     * \param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
      * \param ru the given RU allocation
      * \param v the given set of RUs
      * \return true if the given RU overlaps with the given set of RUs.
      */
-    static bool DoesOverlap(uint16_t bw, RuSpec ru, const std::vector<RuSpec>& v);
+    static bool DoesOverlap(MHz_u bw, RuSpec ru, const std::vector<RuSpec>& v);
 
     /**
      * Check whether the given RU overlaps with the given tone ranges.
      * Note that for channel width of 160 MHz the returned range is relative to
      * the 160 MHz channel (i.e. -1012 to 1012).
      *
-     * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+     * \param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
      * \param ru the given RU allocation
      * \param toneRanges the given set of tone ranges
      * \param p20Index the index of the primary20 channel
      * \return true if the given RU overlaps with the given set of tone ranges.
      */
-    static bool DoesOverlap(uint16_t bw,
+    static bool DoesOverlap(MHz_u bw,
                             RuSpec ru,
                             const SubcarrierGroup& toneRanges,
                             uint8_t p20Index);
@@ -241,28 +232,28 @@
      * reference RU allocation.
      * Note that an assert is generated if the RU allocation is not found.
      *
-     * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+     * \param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
      * \param referenceRu the reference RU allocation
      * \param searchedRuType the searched RU type
      * \return the searched RU allocation.
      */
-    static RuSpec FindOverlappingRu(uint16_t bw, RuSpec referenceRu, RuType searchedRuType);
+    static RuSpec FindOverlappingRu(MHz_u bw, RuSpec referenceRu, RuType searchedRuType);
 
     /**
      * Get the approximate bandwidth occupied by a RU.
      *
      * \param ruType the RU type
-     * \return the approximate bandwidth (in MHz) occupied by the RU
+     * \return the approximate bandwidth occupied by the RU
      */
-    static uint16_t GetBandwidth(RuType ruType);
+    static MHz_u GetBandwidth(RuType ruType);
 
     /**
      * Get the RU corresponding to the approximate bandwidth.
      *
-     * \param bandwidth the approximate bandwidth (in MHz) occupied by the RU
+     * \param bandwidth the approximate bandwidth occupied by the RU
      * \return the RU type
      */
-    static RuType GetRuType(uint16_t bandwidth);
+    static RuType GetRuType(MHz_u bandwidth);
 
     /**
      * Given the channel bandwidth and the number of stations candidate for being
@@ -270,19 +261,19 @@
      * an RU subject to the constraint that all the stations must be assigned an RU
      * of the same size (in terms of number of tones).
      *
-     * \param bandwidth the channel bandwidth in MHz
+     * \param bandwidth the channel bandwidth
      * \param nStations the number of candidate stations. On return, it is set to
      *                  the number of stations that are assigned an RU
      * \param[out] nCentral26TonesRus the number of additional 26-tone RUs that can be
      *                                allocated if the returned RU size is greater than 26 tones
      * \return the RU type
      */
-    static RuType GetEqualSizedRusForStations(uint16_t bandwidth,
+    static RuType GetEqualSizedRusForStations(MHz_u bandwidth,
                                               std::size_t& nStations,
                                               std::size_t& nCentral26TonesRus);
 
     /// (bandwidth, number of tones) pair
-    typedef std::pair<uint8_t, RuType> BwTonesPair;
+    typedef std::pair<MHz_u, RuType> BwTonesPair;
 
     /// map (bandwidth, number of tones) pairs to the group of subcarrier ranges
     typedef std::map<BwTonesPair, std::vector<SubcarrierGroup>> SubcarrierGroups;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/mu-edca-parameter-set.cc ns-3.43/src/wifi/model/he/mu-edca-parameter-set.cc
--- ns-3.42/src/wifi/model/he/mu-edca-parameter-set.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/mu-edca-parameter-set.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/mu-edca-parameter-set.h ns-3.43/src/wifi/model/he/mu-edca-parameter-set.h
--- ns-3.42/src/wifi/model/he/mu-edca-parameter-set.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/mu-edca-parameter-set.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/multi-user-scheduler.cc ns-3.43/src/wifi/model/he/multi-user-scheduler.cc
--- ns-3.42/src/wifi/model/he/multi-user-scheduler.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/multi-user-scheduler.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -51,7 +40,8 @@
                           "even without DL traffic. A null duration indicates that such "
                           "requests shall not be made.",
                           TimeValue(Seconds(0)),
-                          MakeTimeAccessor(&MultiUserScheduler::m_accessReqInterval),
+                          MakeTimeAccessor(&MultiUserScheduler::SetAccessReqInterval,
+                                           &MultiUserScheduler::GetAccessReqInterval),
                           MakeTimeChecker())
             .AddAttribute("AccessReqAc",
                           "The Access Category for which the MultiUserScheduler makes requests "
@@ -94,7 +84,10 @@
     m_apMac = nullptr;
     m_edca = nullptr;
     m_lastTxInfo.clear();
-    m_accessReqTimer.Cancel();
+    for (auto& accessReqTimer : m_accessReqTimers)
+    {
+        accessReqTimer.Cancel();
+    }
     Object::DoDispose();
 }
 
@@ -122,8 +115,15 @@
 
     if (m_accessReqInterval.IsStrictlyPositive())
     {
-        m_accessReqTimer =
-            Simulator::Schedule(m_accessReqInterval, &MultiUserScheduler::AccessReqTimeout, this);
+        NS_ASSERT(m_accessReqTimers.empty());
+        for (uint8_t id = 0; id < m_apMac->GetNLinks(); ++id)
+        {
+            m_accessReqTimers.emplace_back(
+                Simulator::Schedule(m_accessReqInterval,
+                                    &MultiUserScheduler::AccessReqTimeout,
+                                    this,
+                                    id));
+        }
     }
 }
 
@@ -132,14 +132,29 @@
 {
     NS_LOG_FUNCTION(this << interval.As(Time::MS));
     m_accessReqInterval = interval;
-    // start the timer if past initialization
+    // if interval is non-zero, start the timers that are not running if we are past initialization
     if (m_accessReqInterval.IsStrictlyPositive() && IsInitialized())
     {
-        m_accessReqTimer =
-            Simulator::Schedule(m_accessReqInterval, &MultiUserScheduler::AccessReqTimeout, this);
+        m_accessReqTimers.resize(m_apMac->GetNLinks());
+        for (uint8_t id = 0; id < m_apMac->GetNLinks(); ++id)
+        {
+            if (!m_accessReqTimers[id].IsPending())
+            {
+                m_accessReqTimers[id] = Simulator::Schedule(m_accessReqInterval,
+                                                            &MultiUserScheduler::AccessReqTimeout,
+                                                            this,
+                                                            id);
+            }
+        }
     }
 }
 
+Time
+MultiUserScheduler::GetAccessReqInterval() const
+{
+    return m_accessReqInterval;
+}
+
 void
 MultiUserScheduler::SetWifiMac(Ptr<ApWifiMac> mac)
 {
@@ -172,26 +187,26 @@
 }
 
 void
-MultiUserScheduler::AccessReqTimeout()
+MultiUserScheduler::AccessReqTimeout(uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this);
+    NS_LOG_FUNCTION(this << linkId);
 
     // request channel access if not requested yet
     auto edca = m_apMac->GetQosTxop(m_accessReqAc);
 
-    for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); linkId++)
+    if (edca->GetAccessStatus(linkId) == Txop::NOT_REQUESTED)
     {
-        if (edca->GetAccessStatus(linkId) == Txop::NOT_REQUESTED)
-        {
-            m_apMac->GetChannelAccessManager(linkId)->RequestAccess(edca);
-        }
+        m_apMac->GetChannelAccessManager(linkId)->RequestAccess(edca);
     }
 
     // restart timer
     if (m_accessReqInterval.IsStrictlyPositive())
     {
-        m_accessReqTimer =
-            Simulator::Schedule(m_accessReqInterval, &MultiUserScheduler::AccessReqTimeout, this);
+        NS_ASSERT(m_accessReqTimers.size() > linkId);
+        m_accessReqTimers[linkId] = Simulator::Schedule(m_accessReqInterval,
+                                                        &MultiUserScheduler::AccessReqTimeout,
+                                                        this,
+                                                        linkId);
     }
 }
 
@@ -199,7 +214,7 @@
 MultiUserScheduler::NotifyAccessGranted(Ptr<QosTxop> edca,
                                         Time availableTime,
                                         bool initialFrame,
-                                        uint16_t allowedWidth,
+                                        MHz_u allowedWidth,
                                         uint8_t linkId)
 {
     NS_LOG_FUNCTION(this << edca << availableTime << initialFrame << allowedWidth << linkId);
@@ -210,15 +225,17 @@
     m_allowedWidth = allowedWidth;
     m_linkId = linkId;
 
-    if (m_accessReqTimer.IsPending() && m_restartTimerUponAccess)
+    if (m_accessReqTimers.size() > linkId && m_accessReqTimers[linkId].IsPending() &&
+        m_restartTimerUponAccess)
     {
         // restart access timer
-        m_accessReqTimer.Cancel();
+        m_accessReqTimers[linkId].Cancel();
         if (m_accessReqInterval.IsStrictlyPositive())
         {
-            m_accessReqTimer = Simulator::Schedule(m_accessReqInterval,
-                                                   &MultiUserScheduler::AccessReqTimeout,
-                                                   this);
+            m_accessReqTimers[linkId] = Simulator::Schedule(m_accessReqInterval,
+                                                            &MultiUserScheduler::AccessReqTimeout,
+                                                            this,
+                                                            linkId);
         }
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/multi-user-scheduler.h ns-3.43/src/wifi/model/he/multi-user-scheduler.h
--- ns-3.42/src/wifi/model/he/multi-user-scheduler.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/multi-user-scheduler.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -29,6 +18,7 @@
 #include "ns3/wifi-tx-parameters.h"
 
 #include <unordered_map>
+#include <vector>
 
 namespace ns3
 {
@@ -93,14 +83,14 @@
      * \param initialFrame true if the frame being transmitted is the initial frame
      *                     of the TXOP. This is used to determine whether the TXOP
      *                     limit can be exceeded
-     * \param allowedWidth the allowed width in MHz for the next transmission
+     * \param allowedWidth the allowed width for the next transmission
      * \param linkId the ID of the link over which channel access was gained
      * \return the format of the next transmission
      */
     TxFormat NotifyAccessGranted(Ptr<QosTxop> edca,
                                  Time availableTime,
                                  bool initialFrame,
-                                 uint16_t allowedWidth,
+                                 MHz_u allowedWidth,
                                  uint8_t linkId);
 
     /**
@@ -130,6 +120,11 @@
      */
     void SetAccessReqInterval(Time interval);
 
+    /**
+     * \return the duration of the interval between two consecutive requests for channel access
+     */
+    Time GetAccessReqInterval() const;
+
   protected:
     /**
      * Get the station manager attached to the AP on the given link.
@@ -182,12 +177,12 @@
     void NotifyNewAggregate() override;
     void DoInitialize() override;
 
-    Ptr<ApWifiMac> m_apMac;  //!< the AP wifi MAC
-    Ptr<QosTxop> m_edca;     //!< the AC that gained channel access
-    Time m_availableTime;    //!< the time available for frame exchange
-    bool m_initialFrame;     //!< true if a TXOP is being started
-    uint16_t m_allowedWidth; //!< the allowed width in MHz for the current transmission
-    uint8_t m_linkId;        //!< the ID of the link over which channel access has been granted
+    Ptr<ApWifiMac> m_apMac; //!< the AP wifi MAC
+    Ptr<QosTxop> m_edca;    //!< the AC that gained channel access
+    Time m_availableTime;   //!< the time available for frame exchange
+    bool m_initialFrame;    //!< true if a TXOP is being started
+    MHz_u m_allowedWidth;   //!< the allowed width for the current transmission
+    uint8_t m_linkId;       //!< the ID of the link over which channel access has been granted
 
   private:
     /**
@@ -198,11 +193,13 @@
     void SetWifiMac(Ptr<ApWifiMac> mac);
 
     /**
-     * Perform actions required on expiration of the channel access request timer,
-     * such as requesting channel access (if not requested already) and restarting
+     * Perform actions required on expiration of the channel access request timer associated with
+     * the given link, such as requesting channel access (if not requested already) and restarting
      * the channel access request timer.
+     *
+     * \param linkId the ID of the given link
      */
-    void AccessReqTimeout();
+    void AccessReqTimeout(uint8_t linkId);
 
     /**
      * Select the format of the next transmission.
@@ -243,9 +240,10 @@
     };
 
     std::map<uint8_t, LastTxInfo> m_lastTxInfo; ///< Information about the last transmission
-    EventId m_accessReqTimer;      ///< the timer controlling additional channel access requests
-    Time m_accessReqInterval;      ///< duration of the interval between channel access requests
-    AcIndex m_accessReqAc;         ///< AC we request channel access for
+    std::vector<EventId>
+        m_accessReqTimers;    ///< the per-link timer controlling additional channel access requests
+    Time m_accessReqInterval; ///< duration of the interval between channel access requests
+    AcIndex m_accessReqAc;    ///< AC we request channel access for
     bool m_restartTimerUponAccess; ///< whether the channel access timer has to be restarted
                                    ///< upon channel access
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/mu-snr-tag.cc ns-3.43/src/wifi/model/he/mu-snr-tag.cc
--- ns-3.42/src/wifi/model/he/mu-snr-tag.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/mu-snr-tag.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/mu-snr-tag.h ns-3.43/src/wifi/model/he/mu-snr-tag.h
--- ns-3.42/src/wifi/model/he/mu-snr-tag.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/mu-snr-tag.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/obss-pd-algorithm.cc ns-3.43/src/wifi/model/he/obss-pd-algorithm.cc
--- ns-3.42/src/wifi/model/he/obss-pd-algorithm.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/obss-pd-algorithm.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -44,27 +33,27 @@
                           DoubleValue(-82.0),
                           MakeDoubleAccessor(&ObssPdAlgorithm::SetObssPdLevel,
                                              &ObssPdAlgorithm::GetObssPdLevel),
-                          MakeDoubleChecker<double>(-101, -62))
+                          MakeDoubleChecker<dBm_u>(-101, -62))
             .AddAttribute("ObssPdLevelMin",
                           "Minimum value (dBm) of OBSS PD level.",
                           DoubleValue(-82.0),
                           MakeDoubleAccessor(&ObssPdAlgorithm::m_obssPdLevelMin),
-                          MakeDoubleChecker<double>(-101, -62))
+                          MakeDoubleChecker<dBm_u>(-101, -62))
             .AddAttribute("ObssPdLevelMax",
                           "Maximum value (dBm) of OBSS PD level.",
                           DoubleValue(-62.0),
                           MakeDoubleAccessor(&ObssPdAlgorithm::m_obssPdLevelMax),
-                          MakeDoubleChecker<double>(-101, -62))
+                          MakeDoubleChecker<dBm_u>(-101, -62))
             .AddAttribute("TxPowerRefSiso",
                           "The SISO reference TX power level (dBm).",
                           DoubleValue(21),
                           MakeDoubleAccessor(&ObssPdAlgorithm::m_txPowerRefSiso),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<dBm_u>())
             .AddAttribute("TxPowerRefMimo",
                           "The MIMO reference TX power level (dBm).",
                           DoubleValue(25),
                           MakeDoubleAccessor(&ObssPdAlgorithm::m_txPowerRefMimo),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<dBm_u>())
             .AddTraceSource("Reset",
                             "Trace CCA Reset event",
                             MakeTraceSourceAccessor(&ObssPdAlgorithm::m_resetEvent),
@@ -99,8 +88,8 @@
 void
 ObssPdAlgorithm::ResetPhy(HeSigAParameters params)
 {
-    double txPowerMaxSiso = 0;
-    double txPowerMaxMimo = 0;
+    dBm_u txPowerMaxSiso = 0;
+    dBm_u txPowerMaxMimo = 0;
     bool powerRestricted = false;
     // Fetch my BSS color
     Ptr<HeConfiguration> heConfiguration = m_device->GetHeConfiguration();
@@ -116,18 +105,18 @@
         txPowerMaxMimo = m_txPowerRefMimo - (m_obssPdLevel - m_obssPdLevelMin);
         powerRestricted = true;
     }
-    m_resetEvent(bssColor, WToDbm(params.rssiW), powerRestricted, txPowerMaxSiso, txPowerMaxMimo);
+    m_resetEvent(bssColor, params.rssi, powerRestricted, txPowerMaxSiso, txPowerMaxMimo);
     phy->ResetCca(powerRestricted, txPowerMaxSiso, txPowerMaxMimo);
 }
 
 void
-ObssPdAlgorithm::SetObssPdLevel(double level)
+ObssPdAlgorithm::SetObssPdLevel(dBm_u level)
 {
     NS_LOG_FUNCTION(this << level);
     m_obssPdLevel = level;
 }
 
-double
+dBm_u
 ObssPdAlgorithm::GetObssPdLevel() const
 {
     return m_obssPdLevel;
